# -*- coding: utf-8 -*- 
# @Time    : 03/21/2024 
# @Author  : nzooherd 
# @File    : admin.py 
# @Software: Visual Studio Code

from aspect.api import ApiAspect
from config import Config
from controller import BaseController, PornherdBot

from telethon.events import filters, NewMessage

from service.video_service import VideoService

class AdminController(BaseController):
    """
    Admin controller
    """

    def __init__(self, mybot: PornherdBot) -> None:
        super().__init__(mybot)

        self.video_service = VideoService()

    
    @ApiAspect(filters.All(filters.Command('/broadcast'), filters.Chats(Config.TELEGRAM_ADMIN_USER_ID)))
    async def broadcast(self, update: NewMessage):
        pass

    @ApiAspect(filters.All(filters.Command('/unicast'), filters.Chats(Config.TELEGRAM_ADMIN_USER_ID)))
    async def unicast(self, update: NewMessage):
        pass

    @ApiAspect(filters.All(filters.Command('/metadata'), filters.Chats(Config.TELEGRAM_ADMIN_USER_ID)))
    async def metadata(self, update: NewMessage):
        video_bangou = update.text.split(" ")[1]
        await self.video_service.update_metadata(video_bangou)
        return await self.mybot.bot_client.send_message(update.chat, text="Success!")